Package net.commoble.exmachina.api

# Record Class MechanicalGraphKey

java.lang.Object
java.lang.Record
net.commoble.exmachina.api.MechanicalGraphKey

Record Components:
  `levelKey` - ResourceKey of the level the node is in
  `pos` - BlockPos where the node is
  `shape` - NodeSHape identifying the node's position within that blockpos

public record MechanicalGraphKey(net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey, net.minecraft.core.BlockPos pos, NodeShape shape) extends Record
Unique keys of nodes in mechanical graphs.

## Constructor Summary

Constructors
Constructor
Description
`MechanicalGraphKey(net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey, net.minecraft.core.BlockPos pos, NodeShape shape)`
Creates an instance of a `MechanicalGraphKey` record class.

## Method Summary

Modifier and Type
Method
Description
`final boolean`
`equals(Object o)`
Indicates whether some other object is "equal to" this one.
`final int`
`hashCode()`
Returns a hash code value for this object.
`boolean`
`isValidFor(MechanicalGraphKey preferredKey)`
Returns true if this node key is compatible with some connection request given the preferred node key.
`net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level>`
`levelKey()`
Returns the value of the `levelKey` record component.
`net.minecraft.core.BlockPos`
`pos()`
Returns the value of the `pos` record component.
`NodeShape`
`shape()`
Returns the value of the `shape` record component.
`final String`
`toString()`
Returns a string representation of this record class.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### MechanicalGraphKey

public MechanicalGraphKey(net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey, net.minecraft.core.BlockPos pos, NodeShape shape)
Creates an instance of a `MechanicalGraphKey` record class.

Parameters:
  `levelKey` - the value for the `levelKey` record component
  `pos` - the value for the `pos` record component
  `shape` - the value for the `shape` record component

## Method Details

### isValidFor

public boolean isValidFor(MechanicalGraphKey preferredKey)
Returns true if this node key is compatible with some connection request given the preferred node key.

Parameters:
  `preferredKey` - MechanicalGraphKey which some requesting node is trying to form a connection to
Returns:
  true if this node key is compatible with some connection request given the preferred node key

### toString

public final String toString()
Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.

Specified by:
  `toString` in class `Record`
Returns:
  a string representation of this object

### hashCode

public final int hashCode()
Returns a hash code value for this object. The value is derived from the hash code of each of the record components.

Specified by:
  `hashCode` in class `Record`
Returns:
  a hash code value for this object

### equals

public final boolean equals(Object o)
Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.

Specified by:
  `equals` in class `Record`
Parameters:
  `o` - the object with which to compare
Returns:
  `true` if this object is the same as the `o` argument; `false` otherwise.

### levelKey

public net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey()
Returns the value of the `levelKey` record component.

Returns:
  the value of the `levelKey` record component

### pos

public net.minecraft.core.BlockPos pos()
Returns the value of the `pos` record component.

Returns:
  the value of the `pos` record component

### shape

public NodeShape shape()
Returns the value of the `shape` record component.

Returns:
  the value of the `shape` record component